﻿using Sample.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;
using Syncfusion.Linq;


namespace Sample.Controllers
{
    public partial class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {                    
            return View();
        }        
        public ActionResult Event(DataManager dm)
        {
            IEnumerable DataSource = OrderRepository.GetAllRecords();
            DataOperations operation = new DataOperations();
            DataResult result = new DataResult();

            result.result = DataSource;
            if (dm.Search != null)//if search query is not null
            {
                result.result = operation.PerformSearching(result.result, dm.Search);//for search operations
            }
            if (dm.Where != null)
            {
                result.result = operation.PerformWhereFilter(result.result, dm.Where, "and");//for filter operations
            }
            if (dm.Sorted != null)
            {
                result.result = operation.PerformSorting(result.result, dm.Sorted);//for sorting
            }
            result.count = result.result.AsQueryable().Count();
            if (dm.Skip > 0)
                result.result = operation.PerformSkip(result.result, dm.Skip);//for skip action

            if (dm.Take > 0)
                result.result = operation.PerformTake(result.result, dm.Take);//for take action

            return Json(result, JsonRequestBehavior.AllowGet);
        }
        
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
    }

}
